package cz.dix.pe.problems;

/**
 * Each new term in the Fibonacci sequence is generated by adding the previous two terms.
 * By starting with 1 and 2, the first 10 terms will be:
 * <p/>
 * 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...
 * <p/>
 * By considering the terms in the Fibonacci sequence whose values do not exceed four million,
 * find the sum of the even-valued terms.
 */
public class Problem2 implements Problem {

    @Override
    public Object solve() {
        int limit = 4000000;

        /*
        * Even + Even = Even
        * Odd + Odd = Even
        * Odd + Even = Odd
        * => every 3rd number in sequence is even!
        * */
        int evenValuedSum = 0;
        int prelast = 1;
        int last = 2;
        while (last < limit) {
            evenValuedSum += last;
            prelast = (prelast + last) + last; // jump 3 numbers
            last = prelast + prelast - last; // jump 3 numbers
        }
        return evenValuedSum;
    }
}
